> ## Documentation Index
> Fetch the complete documentation index at: https://docs.apimart.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Remix (리셰이프, v8.1 / v8.2 전용)

> v8 패널의 리셰이프(reshape). 부모 이미지를 다시 생성하며 prompt를 바꿀 수 있고, 강 / 약 두 단계

<RequestExample>
  ```bash cURL theme={null}
  curl --request POST \
    --url https://api.apimart.ai/v1/midjourney/generations/remix-strong \
    --header 'Authorization: Bearer <token>' \
    --header 'Content-Type: application/json' \
    --data '{
      "task_id": "task_<v8_imagine_id>",
      "index": 1,
      "speed": "fast"
    }'
  ```

  ```python Python theme={null}
  import requests

  url = "https://api.apimart.ai/v1/midjourney/generations/remix-strong"

  payload = {
      "task_id": "task_<v8_imagine_id>",
      "index": 1,
      "speed": "fast"
  }

  headers = {
      "Authorization": "Bearer <token>",
      "Content-Type": "application/json"
  }

  response = requests.post(url, json=payload, headers=headers)

  print(response.json())
  ```

  ```javascript JavaScript theme={null}
  const url = "https://api.apimart.ai/v1/midjourney/generations/remix-strong";

  const payload = {
    task_id: "task_<v8_imagine_id>",
    index: 1,
    speed: "fast"
  };

  const headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
  };

  fetch(url, {
    method: "POST",
    headers: headers,
    body: JSON.stringify(payload)
  })
    .then(response => response.json())
    .then(data => console.log(data))
    .catch(error => console.error('Error:', error));
  ```

  ```go Go theme={null}
  package main

  import (
      "bytes"
      "encoding/json"
      "fmt"
      "io/ioutil"
      "net/http"
  )

  func main() {
      url := "https://api.apimart.ai/v1/midjourney/generations/remix-strong"

      payload := map[string]interface{}{
          "task_id": "task_<v8_imagine_id>",
          "index": 1,
          "speed": "fast",
      }

      jsonData, _ := json.Marshal(payload)

      req, _ := http.NewRequest("POST", url, bytes.NewBuffer(jsonData))
      req.Header.Set("Authorization", "Bearer <token>")
      req.Header.Set("Content-Type", "application/json")

      client := &http.Client{}
      resp, err := client.Do(req)
      if err != nil {
          panic(err)
      }
      defer resp.Body.Close()

      body, _ := ioutil.ReadAll(resp.Body)
      fmt.Println(string(body))
  }
  ```

  ```java Java theme={null}
  import java.net.http.HttpClient;
  import java.net.http.HttpRequest;
  import java.net.http.HttpResponse;
  import java.net.URI;

  public class Main {
      public static void main(String[] args) throws Exception {
          String url = "https://api.apimart.ai/v1/midjourney/generations/remix-strong";

          String payload = """
          {
            "task_id": "task_<v8_imagine_id>",
            "index": 1,
            "speed": "fast"
          }
          """;

          HttpClient client = HttpClient.newHttpClient();
          HttpRequest request = HttpRequest.newBuilder()
              .uri(URI.create(url))
              .header("Authorization", "Bearer <token>")
              .header("Content-Type", "application/json")
              .POST(HttpRequest.BodyPublishers.ofString(payload))
              .build();

          HttpResponse<String> response = client.send(request,
              HttpResponse.BodyHandlers.ofString());

          System.out.println(response.body());
      }
  }
  ```

  ```php PHP theme={null}
  <?php

  $url = "https://api.apimart.ai/v1/midjourney/generations/remix-strong";

  $payload = [
      "task_id" => "task_<v8_imagine_id>",
      "index" => 1,
      "speed" => "fast",
  ];

  $ch = curl_init($url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_POST, true);
  curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($payload));
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
      "Authorization: Bearer <token>",
      "Content-Type: application/json"
  ]);

  $response = curl_exec($ch);
  curl_close($ch);

  echo $response;
  ?>
  ```

  ```ruby Ruby theme={null}
  require 'net/http'
  require 'json'
  require 'uri'

  url = URI("https://api.apimart.ai/v1/midjourney/generations/remix-strong")

  payload = {
    task_id: "task_<v8_imagine_id>",
    index: 1,
    speed: "fast",
  }

  http = Net::HTTP.new(url.host, url.port)
  http.use_ssl = true

  request = Net::HTTP::Post.new(url)
  request["Authorization"] = "Bearer <token>"
  request["Content-Type"] = "application/json"
  request.body = payload.to_json

  response = http.request(request)
  puts response.body
  ```

  ```swift Swift theme={null}
  import Foundation

  let url = URL(string: "https://api.apimart.ai/v1/midjourney/generations/remix-strong")!

  let payload: [String: Any] = [
      "task_id": "task_<v8_imagine_id>",
      "index": 1,
      "speed": "fast",
  ]

  var request = URLRequest(url: url)
  request.httpMethod = "POST"
  request.setValue("Bearer <token>", forHTTPHeaderField: "Authorization")
  request.setValue("application/json", forHTTPHeaderField: "Content-Type")
  request.httpBody = try? JSONSerialization.data(withJSONObject: payload)

  let task = URLSession.shared.dataTask(with: request) { data, response, error in
      if let error = error {
          print("Error: \(error)")
          return
      }
      
      if let data = data, let responseString = String(data: data, encoding: .utf8) {
          print(responseString)
      }
  }

  task.resume()
  ```

  ```csharp C# theme={null}
  using System;
  using System.Net.Http;
  using System.Text;
  using System.Threading.Tasks;

  class Program
  {
      static async Task Main(string[] args)
      {
          var url = "https://api.apimart.ai/v1/midjourney/generations/remix-strong";

          var payload = @"{
              ""task_id"": ""task_<v8_imagine_id>"",
              ""index"": 1,
              ""speed"": ""fast""
          }";

          using var client = new HttpClient();
          client.DefaultRequestHeaders.Add("Authorization", "Bearer <token>");

          var content = new StringContent(payload, Encoding.UTF8, "application/json");
          var response = await client.PostAsync(url, content);
          var result = await response.Content.ReadAsStringAsync();

          Console.WriteLine(result);
      }
  }
  ```

  ```c C theme={null}
  #include <stdio.h>
  #include <curl/curl.h>

  int main(void) {
      CURL *curl;
      CURLcode res;

      curl_global_init(CURL_GLOBAL_DEFAULT);
      curl = curl_easy_init();

      if(curl) {
          const char *url = "https://api.apimart.ai/v1/midjourney/generations/remix-strong";
          const char *payload = "{"
              "\"task_id\":\"task_<v8_imagine_id>\","
              "\"index\":1,"
              "\"speed\":\"fast\""
          "}";

          struct curl_slist *headers = NULL;
          headers = curl_slist_append(headers, "Authorization: Bearer <token>");
          headers = curl_slist_append(headers, "Content-Type: application/json");

          curl_easy_setopt(curl, CURLOPT_URL, url);
          curl_easy_setopt(curl, CURLOPT_POSTFIELDS, payload);
          curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);

          res = curl_easy_perform(curl);

          if(res != CURLE_OK) {
              fprintf(stderr, "curl_easy_perform() failed: %s\n",
                      curl_easy_strerror(res));
          }

          curl_slist_free_all(headers);
          curl_easy_cleanup(curl);
      }

      curl_global_cleanup();
      return 0;
  }
  ```

  ```objectivec Objective-C theme={null}
  #import <Foundation/Foundation.h>

  int main(int argc, const char * argv[]) {
      @autoreleasepool {
          NSURL *url = [NSURL URLWithString:@"https://api.apimart.ai/v1/midjourney/generations/remix-strong"];
          
          NSDictionary *payload = @{
              @"task_id": @"task_<v8_imagine_id>",
              @"index": @1,
              @"speed": @"fast",
          };
          
          NSError *error;
          NSData *jsonData = [NSJSONSerialization dataWithJSONObject:payload
                                                            options:0
                                                              error:&error];
          
          NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
          [request setHTTPMethod:@"POST"];
          [request setValue:@"Bearer <token>" forHTTPHeaderField:@"Authorization"];
          [request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
          [request setHTTPBody:jsonData];
          
          NSURLSessionDataTask *task = [[NSURLSession sharedSession] 
              dataTaskWithRequest:request
              completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
                  if (error) {
                      NSLog(@"Error: %@", error);
                      return;
                  }
                  NSString *result = [[NSString alloc] initWithData:data 
                                                          encoding:NSUTF8StringEncoding];
                  NSLog(@"%@", result);
              }];
          
          [task resume];
          [[NSRunLoop mainRunLoop] run];
      }
      return 0;
  }
  ```

  ```ocaml OCaml theme={null}
  (* Requires cohttp and yojson libraries *)
  open Lwt
  open Cohttp
  open Cohttp_lwt_unix

  let url = "https://api.apimart.ai/v1/midjourney/generations/remix-strong"

  let payload = {|{
    "task_id": "task_<v8_imagine_id>",
    "index": 1,
    "speed": "fast"
  }|}

  let () =
    let headers = Header.init ()
      |> fun h -> Header.add h "Authorization" "Bearer <token>"
      |> fun h -> Header.add h "Content-Type" "application/json"
    in
    let body = Cohttp_lwt.Body.of_string payload in
    
    let response = Client.post ~headers ~body (Uri.of_string url) >>= fun (resp, body) ->
      body |> Cohttp_lwt.Body.to_string >|= fun body_str ->
      print_endline body_str
    in
    Lwt_main.run response
  ```

  ```dart Dart theme={null}
  import 'dart:convert';
  import 'package:http/http.dart' as http;

  void main() async {
    final url = Uri.parse('https://api.apimart.ai/v1/midjourney/generations/remix-strong');
    
    final payload = {
      'task_id': 'task_<v8_imagine_id>',
      'index': 1,
      'speed': 'fast',
    };
    
    final response = await http.post(
      url,
      headers: {
        'Authorization': 'Bearer <token>',
        'Content-Type': 'application/json',
      },
      body: jsonEncode(payload),
    );
    
    print(response.body);
  }
  ```

  ```r R theme={null}
  library(httr)
  library(jsonlite)

  url <- "https://api.apimart.ai/v1/midjourney/generations/remix-strong"

  payload <- list(
    task_id = "task_<v8_imagine_id>",
    index = 1,
    speed = "fast"
  )

  response <- POST(
    url,
    add_headers(
      Authorization = "Bearer <token>",
      `Content-Type` = "application/json"
    ),
    body = toJSON(payload, auto_unbox = TRUE),
    encode = "raw"
  )

  cat(content(response, "text"))
  ```
</RequestExample>

<ResponseExample>
  ```json 200 theme={null}
  {
    "code": 200,
    "data": [
      {
        "status": "submitted",
        "task_id": "task_01KV52C0TEJSYZMCG0NCS4YWKK"
      }
    ]
  }
  ```

  ```json 400 theme={null}
  {
    "error": {
      "code": 400,
      "message": "잘못된 요청 매개변수입니다",
      "type": "invalid_request_error"
    }
  }
  ```

  ```json 401 theme={null}
  {
    "error": {
      "code": 401,
      "message": "인증 정보가 유효하지 않습니다",
      "type": "authentication_error"
    }
  }
  ```

  ```json 402 theme={null}
  {
    "error": {
      "code": 402,
      "message": "잔액이 부족합니다. 계정에 충전해주세요",
      "type": "payment_required"
    }
  }
  ```

  ```json 403 theme={null}
  {
    "error": {
      "code": 403,
      "message": "접근이 금지되었습니다. 이 리소스에 대한 권한이 없습니다",
      "type": "permission_error"
    }
  }
  ```

  ```json 404 theme={null}
  {
    "error": {
      "code": 404,
      "message": "작업을 찾을 수 없습니다",
      "type": "not_found_error"
    }
  }
  ```

  ```json 422 theme={null}
  {
    "error": {
      "code": 422,
      "message": "이미지 또는 프롬프트가 콘텐츠 검수를 통과하지 못했습니다(자동 환불됨)",
      "type": "invalid_request_error"
    }
  }
  ```

  ```json 429 theme={null}
  {
    "error": {
      "code": 429,
      "message": "요청 한도를 초과했습니다. 나중에 다시 시도해주세요",
      "type": "rate_limit_error"
    }
  }
  ```

  ```json 500 theme={null}
  {
    "error": {
      "code": 500,
      "message": "내부 서버 오류가 발생했습니다. 나중에 다시 시도해주세요",
      "type": "server_error"
    }
  }
  ```

  ```json 502 theme={null}
  {
    "error": {
      "code": 502,
      "message": "불량 게이트웨이입니다. 서버가 일시적으로 사용할 수 없습니다",
      "type": "bad_gateway"
    }
  }
  ```
</ResponseExample>

v8 패널의 "리셰이프" — 부모 이미지를 다시 생성하며 prompt를 바꿀 수 있습니다. **v8.1 / v8.2 부모 작업만 지원**. v7 / v6 부모 이미지는 [Variation](./variation) / [High Variation](./high-variation)을 사용하세요.

```
POST /v1/midjourney/generations/remix-strong
POST /v1/midjourney/generations/remix-subtle
```

> v8 패널은 U1-U4 / zoom / outpaint / inpaint를 제거했습니다. 대체: 변형 → Variation / High Variation, 리셰이프 → 본 엔드포인트, 재생성 → Reroll.

| 항목     | 내용                                                                    |
| ------ | --------------------------------------------------------------------- |
| action | `REMIX_STRONG` / `REMIX_SUBTLE`                                       |
| 과금     | `midjourney@remix_strong[-speed]` / `midjourney@remix_subtle[-speed]` |
| 필수     | `task_id` + `index`                                                   |

## 파라미터

| 필드        | 타입     | 필수  | 기본값     | 설명                                     |
| --------- | ------ | --- | ------- | -------------------------------------- |
| `task_id` | string | 예   | —       | 부모 작업(**v8.1 / v8.2 imagine SUCCESS**) |
| `index`   | int    | 예   | —       | 부모 이미지 중 어느 것을 리셰이프할지(`1`\~`4`)        |
| `prompt`  | string | 아니오 | (부모 상속) | 리셰이프용 새 prompt. 비우면 부모 prompt 사용       |
| `speed`   | string | 아니오 | `relax` | `relax` / `fast` / `turbo`             |

## 강도 비교

| 엔드포인트           | op            |                   변화 정도 | 비유                    |
| --------------- | ------------- | ----------------------: | --------------------- |
| `/remix-strong` | `remixStrong` | 큰 변화, 구도 / 스타일도 바뀔 수 있음 | High Variation(강)과 유사 |
| `/remix-subtle` | `remixSubtle` |        작은 변화, 주제 / 톤 유지 | Variation(약)과 유사      |

## 요청 예시

강한 리셰이프:

```json theme={null}
{
  "task_id": "task_<v8_imagine_id>",
  "index": 1,
  "speed": "fast"
}
```

커스텀 prompt가 그대로 전달되어 스타일 변경 / 디테일 추가가 가능합니다.

## 응답

제출 시 새로운 로컬 `task_id`를 반환합니다. `GET /v1/tasks/{task_id}`를 폴링하면 SUCCESS 시 4장의 리셰이프 이미지를 포함합니다.

## 참고

* **v8.1 / v8.2 부모 이미지만 지원**. v8 계열이 아닌 부모 작업은 `400`을 반환합니다.
* v7 / v6 부모 이미지는 Variation / High Variation / Low Variation을 사용하세요.
